#include <stdio.h>
#include <stdlib.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/proxy.h>
#include <string.h>
#include <math.h>
#include <i86.h>
#include <unistd.h>

#include "regnames.h"
#include "panthermsg.h"
#include "omega.h"

// Set SP1 (set point 1) on a Omega temperature controller.
void setOmegaSP1 ( int address, float valueF ) {

	unsigned char OmegaMsg[4];
	char	Rmsg[3];
	int 	value;
	pid_t 	rs_pid;

	value = floor(10*valueF);

	OmegaMsg[0] = msg_changeSp1;
	OmegaMsg[1] = address;
	OmegaMsg[2] = value>>8;
	OmegaMsg[3] = value&255;

	//printf("msg to OMEGA: value1 = %d, value2 = %d, %d\n", OmegaMsg[2], OmegaMsg[3], OmegaMsg[2]*256+OmegaMsg[3]);

	rs_pid = qnx_name_locate (0, NAME_TEMPS, 0, NULL);
	if ( rs_pid != -1 )
		Send(rs_pid, OmegaMsg, Rmsg, sizeof(OmegaMsg), sizeof(Rmsg));

}

void OmegaReset ( int address ) {

	unsigned char OmegaMsg[2];
	char	Rmsg[3];
	pid_t 	rs_pid;

	OmegaMsg[0] = msg_OmegaReset;
	OmegaMsg[1] = address;

	rs_pid = qnx_name_locate (0, NAME_TEMPS, 0, NULL);
	if ( rs_pid != -1 )
		Send(rs_pid, OmegaMsg, Rmsg, sizeof(OmegaMsg), sizeof(Rmsg));

}
